import { Type } from "./type.js";
export const createWhenParser = (scope) => {
    const parser = (def) => new Type(def, scope).alias;
    return parser;
};
export const createMatchParser = (scope) => {
    // TODO: move to match node, discrimination
    const parser = (cases) => {
        const caseArray = Object.entries(cases).map(([def, morph]) => ({
            when: new Type(def, scope).allows,
            then: morph
        }));
        return (data) => {
            for (const c of caseArray) {
                if (c.when(data)) {
                    return c.then(data, {});
                }
            }
        };
    };
    return parser;
};
//# sourceMappingURL=match.js.map