import { Scanner } from "./string/shift/scanner.js";
const getInnerValue = (value) => {
    if (typeof value === "string") {
        if (value[value.length - 1] === "?") {
            return {
                kind: "optional",
                innerValue: value.slice(0, -1)
            };
        }
    }
    else if (Array.isArray(value)) {
        if (value.length === 2 && value[1] === "?") {
            return {
                kind: "optional",
                innerValue: getInnerValue(value[0]).innerValue
            };
        }
    }
    return {
        kind: "required",
        innerValue: value
    };
};
export const parseEntry = ([key, value]) => {
    const keyParseResult = typeof key === "string" && key.at(-1) === "?"
        ? key.at(-2) === Scanner.escapeToken
            ? { innerKey: `${key.slice(0, -2)}?`, kind: "required" }
            : { innerKey: key.slice(0, -1), kind: "optional" }
        : { innerKey: key, kind: "required" };
    const valueParseResult = getInnerValue(value);
    return {
        innerKey: keyParseResult.innerKey,
        innerValue: valueParseResult.innerValue,
        kind: keyParseResult.kind === "indexed"
            ? "indexed"
            : valueParseResult.kind === "optional"
                ? "optional"
                : keyParseResult.kind
    };
};
//# sourceMappingURL=shared.js.map