import { Scope } from "../scope.js";
import { jsObjectsModule } from "./jsObjects.js";
import { parsingModule } from "./parsing.js";
import { tsGenericsModule } from "./tsGenerics.js";
import { tsKeywordsModule } from "./tsKeywords.js";
import { validationModule } from "./validation.js";
export const ark = Scope.root({
    ...tsKeywordsModule,
    ...jsObjectsModule,
    ...validationModule,
    parse: parsingModule,
    // again, unfortunately TS won't handle comparing generics well here, so we
    // have to cast. that said, since each individual root scope is checked,
    // this is low risk
    ...tsGenericsModule
}).toAmbient();
export const arktypes = ark.export();
export const scope = ark.scope;
export const type = ark.type;
export const match = ark.match;
export const when = ark.when;
export const define = ark.define;
export const declare = ark.declare;
//# sourceMappingURL=ark.js.map